/* lineBres, Chapter 3, pp. 91-92 */

/* EXAMPLE STARTS HERE */
#include "device.h"

void lineBres (int xa, int ya, int xb, int yb) 
{
  int dx = abs (xa - xb), dy = abs (ya - yb);
  int p = 2 * dy - dx;
  int twoDy = 2 * dy, twoDyDx = 2 * (dy - dx);
  int x, y, xEnd;

  /* Determine which point to use as start, which as end */
  if (xa > xb) {
    x = xb;
    y = yb;
    xEnd = xa;
  }
  else {
    x = xa;
    y = ya;
    xEnd = xb;
  }
  setPixel (x, y);

  while (x < xEnd) {
    x++;
    if (p < 0)
      p += twoDy;
    else {
      y++;
      p += twoDyDx; 
    }
    setPixel (x, y);
  }
}
/* EXAMPLE ENDS HERE */

void main (int argc, char ** argv)
{
  long windowID = openGraphics (*argv, WINDOW_WIDTH, WINDOW_HEIGHT);
  setBackground (WHITE);
  setColor (BLACK);
  lineBres
    (WINDOW_WIDTH/4, WINDOW_HEIGHT/4, WINDOW_WIDTH/2, 3*WINDOW_HEIGHT/4);
  sleep (10);
  closeGraphics (windowID);
}
