/* lineDDA, Chapter 3, p. 88 */

/* EXAMPLE STARTS HERE */
#include "device.h"

#define ROUND(a) ((int)(a+0.5))

void lineDDA (int xa, int ya, int xb, int yb)
{
  int dx = xb - xa, dy = yb - ya, steps, k;
  float xIncrement, yIncrement, x = xa, y = ya;

  if (abs (dx) > abs (dy)) steps = abs (dx);
  else steps = abs (dy);
  xIncrement = dx / (float) steps;
  yIncrement = dy / (float) steps;
    
  setPixel (ROUND(x), ROUND(y));
  for (k=0; k<steps; k++) {
    x += xIncrement;
    y += yIncrement;
    setPixel (ROUND(x), ROUND(y));
  }
}
/* EXAMPLE ENDS HERE */

void main (int argc, char ** argv)
{
  long windowID = openGraphics (*argv, WINDOW_WIDTH, WINDOW_HEIGHT);
  setBackground (WHITE);
  setColor (BLACK);
  lineDDA
    (WINDOW_WIDTH/4, WINDOW_HEIGHT/4, WINDOW_WIDTH/2, 3*WINDOW_HEIGHT/4);
  lineDDA
    (WINDOW_WIDTH/2, 3*WINDOW_HEIGHT/4, 3*WINDOW_WIDTH/4, WINDOW_HEIGHT/4);
  lineDDA
    (3*WINDOW_WIDTH/4, WINDOW_HEIGHT/4, WINDOW_WIDTH/4, WINDOW_HEIGHT/4);
  sleep (10);
  closeGraphics (windowID);
}

